CREATE OR REPLACE PACKAGE telsale_archievement_pkg IS

    -- Author  : WANGWEI-202
    -- Created : 2023/3/10 15:13:34
    -- Purpose : Ŀɰ

    TYPE cur_type IS REF CURSOR;

    -- 쳣
    DEPARTMENTCODE_EXCEPTION_CODE CONSTANT INTEGER := -20000;
    DEPARTMENTCODE_EXCEPTION_MSG  CONSTANT VARCHAR2(100) := 'ŴЧ';

    CALLERCODE_EXCEPTION_CODE CONSTANT INTEGER := -20001;
    CALLERCODE_EXCEPTION_MSG  CONSTANT VARCHAR2(100) := 'ϯЧ';

    PROCEDURE department_archievement
    (
        a_department_code IN VARCHAR2,
        a_attaching_rate  OUT VARCHAR2,
        a_renewal_rate    OUT VARCHAR2,
        a_total           OUT INTEGER,
        a_mensual_cur     OUT cur_type
    );

    PROCEDURE caller_archievement
    (
        a_caller_code    IN VARCHAR2,
        a_attaching_rate OUT VARCHAR2,
        a_renewal_rate   OUT VARCHAR2,
        a_total          OUT INTEGER,
        a_present_month  OUT NUMBER,
        a_mensual_cur    OUT cur_type
    );

    PROCEDURE caller_arch_ranking_list
    (
        a_department_code        IN VARCHAR2,
        a_year                   IN VARCHAR2,
        a_month                  IN VARCHAR2,
        a_attaching_ranking_list OUT cur_type,
        a_renewal_ranking_list   OUT cur_type
    );

END telsale_archievement_pkg;
/
CREATE OR REPLACE PACKAGE BODY TELSALE_ARCHIEVEMENT_PKG IS
    -- ҵ
    PROCEDURE DEPARTMENT_ARCHIEVEMENT
    (
        A_DEPARTMENT_CODE IN VARCHAR2,
        A_ATTACHING_RATE  OUT VARCHAR2,
        A_RENEWAL_RATE    OUT VARCHAR2,
        A_TOTAL           OUT INTEGER,
        A_MENSUAL_CUR     OUT CUR_TYPE
    ) IS
        --L_THIS_MONTH      VARCHAR2(4);
        --L_THIS_YEAR       VARCHAR2(4);
        L_FIRSTDAY        DATE;
        L_DEPARTMENT_NAME VARCHAR2(100);
    BEGIN
        /*L_THIS_MONTH := TO_CHAR(SYSDATE,
                                'mm');
        L_THIS_YEAR  := TO_CHAR(SYSDATE,
                                'yyyy');*/
        L_FIRSTDAY := TO_DATE(TO_CHAR(SYSDATE,
                                      'yyyy') || '-01-01 00:00:00',
                              'yyyy-mm-dd hh24:mi:ss');
        -- ȡ
        BEGIN
            SELECT DEPARTMENT_NAME
              INTO L_DEPARTMENT_NAME
              FROM IDST0.BM_T BM
             WHERE BM.DEPARTMENT_CODE = A_DEPARTMENT_CODE;
        EXCEPTION
            -- ûҵƣ˵׳쳣
            WHEN NO_DATA_FOUND THEN
                RAISE_APPLICATION_ERROR(DEPARTMENTCODE_EXCEPTION_CODE,
                                        DEPARTMENTCODE_EXCEPTION_MSG);
        END;
        --͸
        /*SELECT DECODE(SUM(CF.ո˿ͻ),
                     0,
                     0,
                     ROUND((SUM(CF.ںϱ) / SUM(CF.ո˿ͻ) * 100),
                           2))
         INTO A_ATTACHING_RATE
         FROM ϯÿձ CF
        WHERE CF.· = L_THIS_MONTH
          AND CF. = L_THIS_YEAR
          AND Ŵ = A_DEPARTMENT_CODE;*/
        SELECT round(dept.±͸,
                     2)
          INTO A_ATTACHING_RATE
          FROM desktop_archievement_admin.BI͸ʸٱ dept
         WHERE dept. = L_DEPARTMENT_NAME;
        --
        /*SELECT DECODE(SUM(),
                     0,
                     0,
                     ROUND(SUM(ۼ) / SUM() * 100,
                           2))
         INTO A_RENEWAL_RATE
         FROM ϯͳ
        WHERE  = L_DEPARTMENT_NAME;*/
        SELECT round(t."ʣȫ£(%)",
                     2)
          INTO A_RENEWAL_RATE
          FROM BI¸ʸٱ t
         WHERE t.β = L_DEPARTMENT_NAME;
        --ҵ
        SELECT ROUND(NVL(SUM(CF.ո˿ͻ + CF.ںϱ),
                         0),
                     0)
          INTO A_TOTAL
          FROM ϯÿձ CF
         WHERE Ŵ = A_DEPARTMENT_CODE
           AND ǩ >= L_FIRSTDAY
           AND ǩ <= SYSDATE;
        --ÿҵ
        OPEN A_MENSUAL_CUR FOR
            SELECT CF.· MM,
                   ROUND(NVL(SUM(CF.ո˿ͻ + CF.ںϱ) / 10000,
                             0),
                         0) BF
              FROM ϯÿձ CF
             WHERE Ŵ = A_DEPARTMENT_CODE
               AND ǩ >= TO_DATE(TO_CHAR(SYSDATE,
                                           'yyyy') || '-01-01 00:00:00',
                                   'yyyy-mm-dd hh24:mi:ss')
               AND ǩ < TO_DATE(TO_CHAR(SYSDATE,
                                          'yyyy-mm') || '-01 00:00:00',
                                  'yyyy-mm-dd hh24:mi:ss')
             GROUP BY CF.·
             ORDER BY CF.·;
    END;

    /*******************************************************/
    -- ϯҵ
    PROCEDURE caller_archievement
    (
        a_caller_code    IN VARCHAR2,
        a_attaching_rate OUT VARCHAR2,
        a_renewal_rate   OUT VARCHAR2,
        a_total          OUT INTEGER,
        a_present_month  OUT NUMBER,
        a_mensual_cur    OUT cur_type
    ) IS
        l_caller_name     VARCHAR2(100);
        l_department_name VARCHAR2(100);
        --l_this_month      VARCHAR2(4);
        l_this_year VARCHAR2(4);
        --l_firstday        DATE;
        l_rownum INTEGER;
    BEGIN
        --ѯϯƣͲƣ֤
        BEGIN
            SELECT zx.saler_name,
                   bm.department_name
              INTO l_caller_name,
                   l_department_name
              FROM tele_saler      zx,
                   tele_saler_team team,
                   idst0.bm_t      bm
             WHERE zx.saler_code = a_caller_code
               AND zx.team_code = team.team_code
               AND team.department_code = bm.department_code;
            /* SELECT saler_name
             INTO l_caller_name
             FROM tele_saler
            WHERE saler_code = a_caller_code;*/
        EXCEPTION
            -- ûвѯϯƣ˵׳쳣
            WHEN no_data_found THEN
                raise_application_error(CALLERCODE_EXCEPTION_CODE,
                                        CALLERCODE_EXCEPTION_MSG);
        END;
    
        --l_this_month := to_char(SYSDATE,
        --                        'mm');
        l_this_year := to_char(SYSDATE,
                               'yyyy');
        --l_firstday   := to_date(l_this_year || '-01-01 00:00:00',
        --                        'yyyy-mm-dd hh24:mi:ss');
    
        --ܳձ
        SELECT round(nvl(SUM(cf.ո˿ͻ),
                         0),
                     2) bf
          INTO a_total
          FROM ϯÿձ cf
         WHERE cf.ϯ = l_caller_name
           AND cf. = l_department_name
           AND cf. = l_this_year;
    
        --͸
        SELECT rownum,
               round(nvl(t.±͸,
                         0),
                     2),
               round(nvl(t."ձ()" * 10000,
                         0),
                     2)
          INTO l_rownum,
               a_attaching_rate,
               a_present_month
          FROM BIϯ͸ʸٱ t
         WHERE t. = l_caller_name
           AND rownum = 1;
        --
        SELECT rownum,
               round(nvl(t."ʣȫ£(%)",
                         0),
                     2)
          INTO l_rownum,
               a_renewal_rate
          FROM BIϯʸٱ t
         WHERE t. = l_caller_name
           AND rownum = 1;
    
        --ÿҵ
        OPEN A_MENSUAL_CUR FOR
            SELECT CF.· MM,
                   ROUND(NVL(SUM(CF.ո˿ͻ),
                             0),
                         0) BF
              FROM ϯÿձ CF
             WHERE cf.ϯ = l_caller_name
               AND cf. = l_department_name
               AND ǩ >= TO_DATE(TO_CHAR(SYSDATE,
                                           'yyyy') || '-01-01 00:00:00',
                                   'yyyy-mm-dd hh24:mi:ss')
               AND ǩ <= SYSDATE
             GROUP BY CF.·
             ORDER BY CF.·;
    END;

    /*******************************************************/
    -- ϯа
    PROCEDURE CALLER_ARCH_RANKING_LIST
    (
        A_DEPARTMENT_CODE        IN VARCHAR2,
        A_YEAR                   IN VARCHAR2,
        A_MONTH                  IN VARCHAR2,
        A_ATTACHING_RANKING_LIST OUT CUR_TYPE,
        A_RENEWAL_RANKING_LIST   OUT CUR_TYPE
    ) IS
        L_DEPARTMENT_NAME VARCHAR2(100);
    BEGIN
        -- ȡ
        BEGIN
            SELECT DEPARTMENT_NAME
              INTO L_DEPARTMENT_NAME
              FROM IDST0.BM_T BM
             WHERE BM.DEPARTMENT_CODE = A_DEPARTMENT_CODE;
        EXCEPTION
            -- ûҵƣ˵׳쳣
            WHEN NO_DATA_FOUND THEN
                RAISE_APPLICATION_ERROR(DEPARTMENTCODE_EXCEPTION_CODE,
                                        DEPARTMENTCODE_EXCEPTION_MSG);
        END;
        -- ںа
        OPEN A_ATTACHING_RANKING_LIST FOR
            SELECT rownum,
                   paihang. AS caller_name,
                   paihang.attaching_rate
              FROM (SELECT DISTINCT *
                      FROM (SELECT t.,
                                   round(t.±͸,
                                         2) attaching_rate,
                                   zuoxi.department_name
                              FROM BIϯ͸ʸٱ t,
                                   (SELECT DISTINCT t.saler_code,
                                                    t.saler_name,
                                                    t.team_code,
                                                    team.team,
                                                    bm.department_name
                                      FROM tele_saler      t,
                                           tele_saler_team team,
                                           idst0.bm_t      bm
                                     WHERE t.team_code = team.team_code
                                       AND team.department_code = bm.department_code
                                       AND bm.department_name = L_DEPARTMENT_NAME) zuoxi
                             WHERE t. = zuoxi.saler_name) st
                     ORDER BY st.department_name,
                              st.attaching_rate DESC) paihang;
        -- а
        OPEN A_RENEWAL_RANKING_LIST FOR
            SELECT rownum,
                   paihang. AS CALLER_NAME,
                   paihang.xbl    AS RENEWAL_RATE
              FROM (SELECT DISTINCT *
                      FROM (SELECT t.,
                                   round(t."ʣȫ£(%)",
                                         2) xbl,
                                   zuoxi.department_name
                              FROM BIϯʸٱ t,
                                   (SELECT DISTINCT t.saler_code,
                                                    t.saler_name,
                                                    t.team_code,
                                                    team.team,
                                                    bm.department_name
                                      FROM tele_saler      t,
                                           tele_saler_team team,
                                           idst0.bm_t      bm
                                     WHERE t.team_code = team.team_code
                                       AND team.department_code = bm.department_code
                                       AND bm.department_name = L_DEPARTMENT_NAME) zuoxi
                             WHERE t. = zuoxi.saler_name) xb
                     ORDER BY xb.department_name,
                              xb.xbl DESC) paihang;
    END;
BEGIN
    NULL;
END TELSALE_ARCHIEVEMENT_PKG;
/
